#include<stdio.h>
#include<net/gen/in.h>
#include<net/gen/socket.h>
#include<sys/socket.h>
#include<net/hton.h>
#include<netinet/in.h>
#include"svc.h"

static int fatal(char * str)
{
	printf("\n %s", str);
	exit(0);	
}
int svc_setup_socket(struct svc_serv * serv, int protocol, unsigned short port)
{
/*  you store a socket descriptor in the svc_serv   */
	int sd, domain, type, retVal = 0;
	unsigned short portNum = htons(port);
	struct sockaddr_in sin;
	socklen_t address_len;
	sin.sin_family = AF_INET;
	sin.sin_port = portNum;
	sin.sin_addr.s_addr = INADDR_ANY; 
	domain = AF_INET;
	type = (protocol == IPPROTO_UDP)? SOCK_DGRAM : SOCK_STREAM;
	sd = socket(domain, type, protocol);
	if(!sd)
	{
		fatal("Could not get any socket ! So aborting !");
	}
	if(0 > bind(sd,(struct sockaddr *) &sin, sizeof(sin)))
	{
		fatal("bind() from svc_setup_socket");
	}
	printf("\n bound a socket to port %d \n", port);
	if(type == SOCK_STREAM)
	{
 		if(0> (retVal = listen(sd,5)))
		{
			fatal("listen() from svc_setup_socket");
		}
		printf("\n Listening on port %d\n", port);	
	}
	serv->sockFd = sd;
	return sd;	
}
